import 'package:flutter/material.dart';
import 'package:kvalifika_sdk/kvalifika_sdk.dart';

void main() {
  runApp(MyApp());
}

class MyApp extends StatefulWidget {
  @override
  _MyAppState createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  int counter = -1;

  @override
  void initState() {
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        appBar: AppBar(
          title: const Text('Kvalifika'),
        ),
        body: Builder(
          builder: (context) {
            return KvalifikaSdk(
              // appId: "7bd2bab9-5bcb-4f8d-a0c8-d7fd3fd4653b", // Production
              appId: "d4bb88d7-8e6d-4653-baef-9d87c1e102e6", // Development
              development: true,
              locale: KvalifikaSdkLocale.EN,
              logo: "logo",
              documentIcon: "logo",
              onInitialize: () {
                ScaffoldMessenger.of(context).showSnackBar(
                  SnackBar(
                    content: Text('SDK Initialized'),
                  ),
                );
                setState(() {
                  counter = 0;
                });
              },
              onStart: (sessionId) {
                ScaffoldMessenger.of(context).showSnackBar(
                  SnackBar(
                    content: Text('Started Verification'),
                  ),
                );
                setState(() {
                  counter++;
                });
              },
              onFinish: (sessionId) {},
              onError: (error, message) {
                print(error);

                if (error == KvalifikaSdkError.INVALID_APP_ID) {}

                if (error == KvalifikaSdkError.TIMEOUT) {
                  ScaffoldMessenger.of(context).showSnackBar(
                    SnackBar(
                      content: Text('Timeout'),
                    ),
                  );
                }

                if (error == KvalifikaSdkError.USER_CANCELLED) {
                  print("user cancelled");
                }

                if (error == KvalifikaSdkError.SESSION_UNSUCCESSFUL) {}

                if (error == KvalifikaSdkError.ID_UNSUCCESSFUL) {}

                if (error == KvalifikaSdkError.CAMERA_PERMISSION_DENIED) {}

                if (error == KvalifikaSdkError.LANDSCAPE_MODE_NOT_ALLOWED) {}

                if (error == KvalifikaSdkError.REVERSE_PORTRAIT_NOT_ALLOWED) {}

                if (error == KvalifikaSdkError.FACE_IMAGES_UPLOAD_FAILED) {}

                if (error == KvalifikaSdkError.DOCUMENT_IMAGES_UPLOAD_FAILED) {}

                if (error == KvalifikaSdkError.COMPARE_IMAGES_FAILED) {}

                if (error == KvalifikaSdkError.UNKNOWN_INTERNAL_ERROR) {}
              },
              builder: (BuildContext context, KvalifikaSdk sdk) {
                return Center(
                  child: Column(
                    mainAxisAlignment: MainAxisAlignment.center,
                    children: [
                      ElevatedButton(
                        key: const Key('start_session'),
                        onPressed: () {
                          sdk.startSession();
                        },
                        child: Text('Start Verification'),
                      ),
                      SizedBox(
                        height: 10,
                      ),
                      Text(
                        '$counter',
                        key: const Key('counter'),
                      ),
                    ],
                  ),
                );
              },
            );
          },
        ),
      ),
    );
  }
}
